package com.its.op.service.its.cctv;

import com.its.op.dao.repository.its.cctv.TbCctvCptnStupRepository;
import com.its.op.dto.its.cctv.TbCctvCptnStupDto;
import com.its.op.entity.its.cctv.TbCctvCptnStup;
import com.its.op.entity.its.cctv.TbCctvCptnStupKey;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbCctvCptnStupService {

    private final TbCctvCptnStupRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbCctvCptnStup requireOne(TbCctvCptnStupKey id) throws NoSuchElementException {
        Optional<TbCctvCptnStup> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return this.repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbCctvCptnStupDto> findAll() {
        List<TbCctvCptnStupDto> result = new ArrayList<>();
        List<TbCctvCptnStup> data = this.repo.findAll();
        for (TbCctvCptnStup entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbCctvCptnStupDto findById(TbCctvCptnStupKey id) {
        TbCctvCptnStup entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbCctvCptnStupDto updateById(TbCctvCptnStupKey id, TbCctvCptnStupDto.TbCctvCptnStupUpdReq req) {
        TbCctvCptnStup entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbCctvCptnStupDto> mergeInfoList(List<TbCctvCptnStupDto.TbCctvCptnStupUpdReq> reqList) {
        List<TbCctvCptnStupDto> result = new ArrayList<>();
        for (TbCctvCptnStupDto.TbCctvCptnStupUpdReq req : reqList) {
            TbCctvCptnStup obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbCctvCptnStupDto mergeInfo(TbCctvCptnStupDto.TbCctvCptnStupUpdReq req) {
        TbCctvCptnStup obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbCctvCptnStupDto deleteById(TbCctvCptnStupKey id) {
        TbCctvCptnStup entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbCctvCptnStupDto> deleteByIds(List<TbCctvCptnStupKey> ids) {
        List<TbCctvCptnStupDto> result = new ArrayList<>();
        for (TbCctvCptnStupKey id : ids) {
            Optional<TbCctvCptnStup> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
